import drugrefapi_base, pyPgSQL as dbapi
from copy import copy

class holbrook(drugrefapi_base.drugrefapi):
	def __init__(self, host='localhost', port=8123, database='drugref2', user='drugref', pwd='drugref', backend='postgres'):
		drugrefapi_base.drugrefapi.__init__(self, host, port, database, user, pwd, backend)
		self.addfunc(self.checkinteractionsATC, '_search_interactions', ['interactions_byATC'])
                print "holbrook init"

	def legend(self, keyword):
		if keyword == 'effect':
			return {'a':'augments (no clinical effect)', 'A':'augments',
			 'i':'inhibts  (no clinical effect)', 'I':'inhibits',
			 'n':'has no effect on', 'N':'has no effect on', ' ': 'unknown effect on'}
		elif keyword == 'significance':
			return {'1':'minor', '2':'moderate', '3':'major', ' ':'unknown'}
		elif keyword == 'evidence':
			return {'P':'poor', 'F':'fair', 'G':'good', ' ':'unknown'}

	def checkinteractionsATC(self, druglist):
                print "checking interactions for plugins hol2 ", druglist
                idrugs = []
		interactions = []
		for drug in druglist:
                        idrugs = copy(druglist)
			idrugs.remove(drug)
			for idrug in idrugs:
				query = "select * from holbrook.interactions where affectingatc = %(affecting)s and affectedatc = %(affected)s"
				#print query % {'affecting':drug, 'affected':idrug}
				results = self._runquery(query, {'affecting':drug, 'affected':idrug})
				for result in results:
					interaction = {}
					interaction['affectingatc'] = result['affectingatc']
					interaction['affectedatc'] = result['affectedatc']
					interaction['affectingdrug'] = result['affectingdrug']
					interaction['affecteddrug'] = result['affecteddrug']
			        	interaction['significance'] = result['significance']
					interaction['effect'] = result['effect']
					interaction['evidence'] = result['evidence']
					interaction['comment'] = result['comment']
					interactions.append(interaction)
		return interactions

	#def checkinteractionsNames(self, nameslist):



import drugrefapi_plugin
class drugrefplugin(drugrefapi_plugin.drugrefplugin):
	def __init__(self):
		drugrefapi_plugin.drugrefplugin.__init__(self)
		self._name = "Holbrook Drug Interactions"
		self._version = "1.0"
		self._plugin = holbrook(database='drugref2')
		self._provides = self._plugin.list_capabilities()


if __name__ == "__main__":
	api = holbrook(database='interactions')
	interactions =  api.get('interactions_byATC', ['N02BE01','N05BA01', 'N05BA12'])
	effect = api.legend('effect')
	significance = api.legend('significance')
	evidence = api.legend('evidence')

	for interaction in interactions:
		print interaction['affectingatc'], " (", interaction['affectingdrug'], ")", effect[interaction['effect']] , interaction['affectedatc'], " (", interaction['affecteddrug'] , ")", "\nSignificance of interaction is", significance[interaction['significance']], "Evidence is", evidence[interaction['evidence']]
		if len(interaction['comment'])>0:
			print "Comment:", interaction['comment']
